usblp Kernel module needs to be removed and /dev/bus/usb/*/* made accessible for USB printers to work with CUPS 1.4.x

Bug #420015 reported by NoahY on 2009-08-27
194
This bug affects 27 people
Affects Status Importance Assigned to Milestone
cups (Ubuntu)
High
Unassigned
Karmic
High
Unassigned
udev (Ubuntu)
Wishlist
Martin Pitt
Karmic
Wishlist
Unassigned

Bug Description

Binary package hint: cups

As of updates this morning, my local USB connected Epson Stylus C66 is no longer found by Ubuntu Karmic Alpha. It worked before, and the driver was still installed, but even when plugged in:

$ lsusb
...
Bus 008 Device 003: ID 04b8:0005 Seiko Epson Corp. Stylus D88+
...

I was told that the printer is offline or disconnected. I deleted the printer from System>Adminstration>Printing, then searched for it, and it was not found. Enclosed is the troubleshooting info.

To reproduce, just plug in the local printer, turn it on, then try to add a new printer in System>Adminstration>Printing (actually, if I remember correctly, it should be recognized automatically once it is plugged in and turned on).

ProblemType: Bug
Architecture: amd64
CupsErrorLog:
 E [27/Aug/2009:08:43:10 -0700] [cups-driverd] Skipping "/usr/share/ppd/1-local-admin": loop detected!
 E [27/Aug/2009:08:45:41 -0700] Unable to remove temporary file "/var/spool/cups/tmp/.hplip" - Is a directory
 E [27/Aug/2009:08:47:06 -0700] [cups-driverd] Skipping "/usr/share/ppd/1-local-admin": loop detected!
 E [27/Aug/2009:08:48:10 -0700] [cups-driverd] Skipping "/usr/share/ppd/1-local-admin": loop detected!
 E [27/Aug/2009:08:48:38 -0700] [cups-driverd] Skipping "/usr/share/ppd/1-local-admin": loop detected!
Date: Thu Aug 27 08:57:16 2009
DistroRelease: Ubuntu 9.10
Lpstat: Error: command ['lpstat', '-v'] failed with exit code 1: lpstat: No destinations added.
MachineType: Acer Aspire 6930G
NonfreeKernelModules: nvidia
Package: cups 1.4.0~svn8773-1
Papersize: letter
PccardctlIdent:

PccardctlStatus:

ProcCmdLine: BOOT_IMAGE=/boot/vmlinuz-2.6.31-7-generic root=UUID=a301128a-e5ba-44c8-9b56-6f991b3979b3 ro quiet splash
ProcEnviron:
 PATH=(custom, user)
 LANG=en_US.UTF-8
 SHELL=/bin/bash
ProcVersionSignature: Ubuntu 2.6.31-7.27-generic
SourcePackage: cups
Uname: Linux 2.6.31-7-generic x86_64
dmi.bios.date: 09/25/2008
dmi.bios.vendor: Acer
dmi.bios.version: v0.3204
dmi.board.name: Makalu
dmi.board.vendor: Acer
dmi.board.version: Not Applicable
dmi.chassis.type: 1
dmi.chassis.vendor: Acer
dmi.chassis.version: N/A
dmi.modalias: dmi:bvnAcer:bvrv0.3204:bd09/25/2008:svnAcer:pnAspire6930G:pvrNotApplicable:rvnAcer:rnMakalu:rvrNotApplicable:cvnAcer:ct1:cvrN/A:
dmi.product.name: Aspire 6930G
dmi.product.version: Not Applicable
dmi.sys.vendor: Acer

NoahY (noahy) wrote :
NoahY (noahy) wrote :
NoahY (noahy) wrote :

Here's what I get when I plug the printer in:

$ dmesg
...
[ 5441.420591] usb 8-2: new full speed USB device using uhci_hcd and address 3
[ 5441.598336] usb 8-2: configuration #1 chosen from 1 choice
[ 5441.607247] usblp0: USB Bidirectional printer dev 3 if 0 alt 0 proto 2 vid 0x04B8 pid 0x0005
[ 5442.782444] type=1503 audit(1251419314.664:14): operation="open" pid=7836 parent=7833 profile="/usr/sbin/cupsd" requested_mask="::r" denied_mask="::r" fsuid=7 ouid=0 name="/dev/bus/usb/"

NoahY (noahy) wrote :

Here's more from the debug log after plugging the printer in:

Aug 27 17:28:33 my-desktop udev-configure-printer: add /devices/pci0000:00/0000:00:1d.2/usb8/8-2/8-2:1.0
Aug 27 17:28:33 my-desktop udev-configure-printer: parent devpath is /devices/pci0000:00/0000:00:1d.2/usb8/8-2
Aug 27 17:28:33 my-desktop udev-configure-printer: Device vendor/product is 04B8:0005
Aug 27 17:28:33 my-desktop udev-configure-printer: add /devices/pci0000:00/0000:00:1d.2/usb8/8-2/8-2:1.0/usb/lp0
Aug 27 17:28:33 my-desktop udev-configure-printer: failed to claim interface
Aug 27 17:28:33 my-desktop udev-configure-printer: parent devpath is /devices/pci0000:00/0000:00:1d.2/usb8/8-2
Aug 27 17:28:33 my-desktop udev-configure-printer: MFG:EPSON MDL:Stylus C66 SERN:- serial:L57040505130842230
Aug 27 17:32:32 my-desktop udev-configure-printer: remove /devices/pci0000:00/0000:00:1d.2/usb8/8-2
Aug 27 17:32:35 my-desktop udev-configure-printer: add /devices/pci0000:00/0000:00:1d.2/usb8/8-2/8-2:1.0
Aug 27 17:32:35 my-desktop udev-configure-printer: add /devices/pci0000:00/0000:00:1d.2/usb8/8-2/8-2:1.0/usb/lp0
Aug 27 17:32:35 my-desktop udev-configure-printer: parent devpath is /devices/pci0000:00/0000:00:1d.2/usb8/8-2
Aug 27 17:32:35 my-desktop udev-configure-printer: Device vendor/product is 04B8:0005
Aug 27 17:32:35 my-desktop udev-configure-printer: failed to claim interface
Aug 27 17:32:35 my-desktop udev-configure-printer: parent devpath is /devices/pci0000:00/0000:00:1d.2/usb8/8-2
Aug 27 17:32:35 my-desktop udev-configure-printer: MFG:EPSON MDL:Stylus C66 SERN:- serial:L57040505130842230

Till Kamppeter (till-kamppeter) wrote :

This is due to the changes of the new CUPS 1.4.0 in Karmic. The problem is caused by a new USB CUPS backend. For this backend the "usblp" kernel module must be unloaded.

Edit /etc//etc/modprobe.d/blacklist.conf adding a line

blacklist usblp

and then run the command

sudo rmmod usblp

Now CUPS should see your USB printers again.

Changed in cups (Ubuntu):
status: New → Confirmed
summary: - Local printer not found (epson stylus c66)
+ usblp Kernel module needs to be removed for USB printers to work with
+ CUPS 1.4.x
summary: - usblp Kernel module needs to be removed for USB printers to work with
- CUPS 1.4.x
+ usblp Kernel module needs to be removed and /dev/bus/usb/*/* made
+ accessible for USB printers to work with CUPS 1.4.x
Till Kamppeter (till-kamppeter) wrote :

In addition to removing the kernel module, the CUPS "usb" backend needs full access to the /dev/bus/usb/*/* files to get fully functional. The settings in /etc/apparmor.d/usr.sbin.cupsd need to get adapted.

Currently, I get audit messages like that in /var/log/syslog:

Aug 28 13:49:51 till-laptop kernel: [330386.770396] type=1502 audit(1251460191.621:2380): operation="open" pid=3873 parent=3871 profile="/usr/sbin/cupsd" requested_mask="::r" denied_mask="::r" fsuid=7 ouid=0 name="/dev/bus/usb/"
Aug 28 13:49:51 till-laptop kernel: [330386.770437] type=1502 audit(1251460191.621:2381): operation="file_perm" pid=3873 parent=3871 profile="/usr/sbin/cupsd" requested_mask="::r" denied_mask="::r" fsuid=7 ouid=0 name="/dev/bus/usb/"
Aug 28 13:49:51 till-laptop kernel: [330386.770489] type=1502 audit(1251460191.621:2382): operation="open" pid=3873 parent=3871 profile="/usr/sbin/cupsd" requested_mask="::r" denied_mask="::r" fsuid=7 ouid=0 name="/dev/bus/usb/"
Aug 28 13:49:51 till-laptop kernel: [330386.770510] type=1502 audit(1251460191.621:2383): operation="file_perm" pid=3873 parent=3871 profile="/usr/sbin/cupsd" requested_mask="::r" denied_mask="::r" fsuid=7 ouid=0 name="/dev/bus/usb/"
Aug 28 13:49:51 till-laptop kernel: [330386.770567] type=1502 audit(1251460191.621:2384): operation="file_perm" pid=3873 parent=3871 profile="/usr/sbin/cupsd" requested_mask="::r" denied_mask="::r" fsuid=7 ouid=0 name="/dev/bus/usb/"

Changed in cups (Ubuntu):
assignee: nobody → Martin Pitt (pitti)
NoahY (noahy) wrote :

@Till - Thanks! Not that it works yet, but at least someone who knows what's going on has taken interest :)

Confirmed, after rmmod, I get a new message after the old ones:

type=1503 audit(1251473058.025:14): operation="open" pid=4700 parent=4696 profile="/usr/sbin/cupsd" requested_mask="::r" denied_mask="::r" fsuid=7 ouid=0 name="/dev/bus/usb/"

NoahY (noahy) wrote :

Oh wait, no, that message was there before... I don't see a difference, then.

Till Kamppeter (till-kamppeter) wrote :

As long as the AppArmor configuration for CUPS is not fixed yet, please run the command line

sudo aa-complain cupsd

and USB printing should work again.

As soon as a fixed CUPS package is there, return to the default mode via

sudo aa-enforce cupsd

NoahY (noahy) wrote :

Thanks, I must be doing something wrong... now I get all the messages you printed out above:

[ 2014.320739] type=1502 audit(1251474493.201:17): operation="open" pid=5401 parent=5397 profile="/usr/sbin/cupsd" requested_mask="::r" denied_mask="::r" fsuid=7 ouid=0 name="/dev/bus/usb/"
[ 2014.320789] type=1502 audit(1251474493.201:18): operation="file_perm" pid=5401 parent=5397 profile="/usr/sbin/cupsd" requested_mask="::r" denied_mask="::r" fsuid=7 ouid=0 name="/dev/bus/usb/"
[ 2014.320849] type=1502 audit(1251474493.201:19): operation="open" pid=5401 parent=5397 profile="/usr/sbin/cupsd" requested_mask="::r" denied_mask="::r" fsuid=7 ouid=0 name="/dev/bus/usb/"
[ 2014.320873] type=1502 audit(1251474493.201:20): operation="file_perm" pid=5401 parent=5397 profile="/usr/sbin/cupsd" requested_mask="::r" denied_mask="::r" fsuid=7 ouid=0 name="/dev/bus/usb/"
[ 2014.320965] type=1502 audit(1251474493.201:21): operation="file_perm" pid=5401 parent=5397 profile="/usr/sbin/cupsd" requested_mask="::r" denied_mask="::r" fsuid=7 ouid=0 name="/dev/bus/usb/"
[ 2014.321076] type=1502 audit(1251474493.205:22): operation="open" pid=5401 parent=5397 profile="/usr/sbin/cupsd" requested_mask="::r" denied_mask="::r" fsuid=7 ouid=0 name="/dev/bus/usb/008/"
[ 2014.321101] type=1502 audit(1251474493.205:23): operation="file_perm" pid=5401 parent=5397 profile="/usr/sbin/cupsd" requested_mask="::r" denied_mask="::r" fsuid=7 ouid=0 name="/dev/bus/usb/008/"
[ 2014.321165] type=1502 audit(1251474493.205:24): operation="open" pid=5401 parent=5397 profile="/usr/sbin/cupsd" requested_mask="::r" denied_mask="::r" fsuid=7 ouid=0 name="/dev/bus/usb/008/005"
[ 2014.321217] type=1502 audit(1251474493.205:25): operation="file_perm" pid=5401 parent=5397 profile="/usr/sbin/cupsd" requested_mask="::r" denied_mask="::r" fsuid=7 ouid=0 name="/dev/bus/usb/008/005"
[ 2014.321252] type=1502 audit(1251474493.205:26): operation="file_perm" pid=5401 parent=5397 profile="/usr/sbin/cupsd" requested_mask="::r" denied_mask="::r" fsuid=7 ouid=0 name="/dev/bus/usb/008/005"

ilna (a-gaydenko) wrote :

Have removed usblp module, also removed cupsd from apparmor, restarted cups - still a printer isn't visible by cups.

Which additional info must I supply?

NoahY (noahy) wrote :

same here... still no printer.

Can you all post the output of the following commands:

/usr/lib/cups/backend/usb
ls -l /dev/bus/usb/*/*
lsusb
lsusb -vvv

ilna (a-gaydenko) wrote :

Till,

Attached.

NoahY (noahy) wrote :

Thanks again for taking time with this...

Some commands gave errors as a normal user, so I've included both with and without "sudo", though I imagine you only need the ones using "sudo"...

NoahY (noahy) wrote :

Hmm... this looks interesting:

$ /usr/lib/cups/backend/usb
DEBUG: list_devices
DEBUG: usb_find_busses=8
DEBUG: usb_find_devices=12
DEBUG: Failed to set configuration 1 for 04b8:0005
DEBUG: Failed to claim interface 0 for 04b8:0005: Operation not permitted

$ sudo /usr/lib/cups/backend/usb
DEBUG: list_devices
DEBUG: usb_find_busses=8
DEBUG: usb_find_devices=12

We need also to introduce a UDEV rule which makes the /dev/bus/usb/*/* files being owned by the "lp" group for all printers (not only HP). Currently this is only set for HP printers by /lib/udev/rules.d/40-hplip.rules. We must add something apprpriate to for example /lib/udev/rules.d/50-udev-default.rules but valid for all printers.

ilna (a-gaydenko) wrote :

At my case I have not found any differences with and without 'sudo'.

Changed in udev (Ubuntu):
importance: Undecided → High
Changed in cups (Ubuntu):
importance: Undecided → High
Changed in udev (Ubuntu):
status: New → Confirmed
ilna (a-gaydenko) wrote :

Till,

At my case, as I can understand, USB backend does see the printer (and can not find it).

Can you do the following test:

Run

lsusb

and look for the line of your printer. The printer has a Bus and a Device number. Now run

sudo chgrp lp /dev/bus/usb/<bus number>/<device number>
sudo chmod 664 /dev/bus/usb/<bus number>/<device number>

with <bus number> and <device number> being padded with zeros to be always of 3 digits (8 -> 008, 11 -> 011, ...).

Example:

till@till-laptop:~/ubuntu/cups/bzr/debian-trunk$ lsusb
Bus 002 Device 029: ID 03f0:1c02 Hewlett-Packard PhotoSmart A710 series
till@till-laptop:~/ubuntu/cups/bzr/debian-trunk$ sudo chgrp lp /dev/bus/usb/002/029
till@till-laptop:~/ubuntu/cups/bzr/debian-trunk$ sudo chmod 664 /dev/bus/usb/002/029

Then try to add a print queue and print to it. Does it work?

Note: Do not turn off or unplug the printer during this procedure, otherwise you will have to do all steps again (device number changes then).

NoahY (noahy) wrote :

I don't know if it helps, but I was able to find and add the printer using foomatic-gui; I had to use an optional ppd from gimp-print project to do so, and the result was a non-functioning visible printer in System>Administration>Printing.

Any workaround while we're waiting for updates?

NoahY (noahy) wrote :

Ah, sorry, I posted before seeing post 20. Yay... it works here! Test page printed successfully.

Truthiswithin, Thanks.

Now we know what to do:

1. Remove/blacklist "usblp" kernel module (for example by adding a file /etc/modprobe.d/blacklist-cups.conf to the cups package and also "rmmod usblp" to the pre- or post-install script of cups)

2. Add udev rules to make the /dev/bus/usb/*/* files corresponding to printers have the permissions 664 and group ownership "lp".

3. Change AppArmor configuration to let the "usb" CUPS backend (or CUPS in general) have read and write access to the /dev/bus/usb/*/* files.

With all this done USB printers will work out-of-the-box again.

Changed in udev (Ubuntu):
status: Confirmed → Triaged
Changed in cups (Ubuntu):
status: Confirmed → Triaged
ilna (a-gaydenko) wrote :

For me owner/rights manipulations didn't help. For this ones

$ lsusb | grep Kyocera
Bus 005 Device 002: ID 0482:0015 Kyocera Corp.
$ sudo ls -l /dev/bus/usb/005/002
crw-r--r-- 1 root lp 189, 513 2009-08-28 22:56 /dev/bus/usb/005/002

restarted CUPS admin still don't find a printer (while USB backend see it).

NoahY (noahy) wrote :

@ilna, did you issue all of the following commands?

$ sudo rmmod usblp
$ sudo aa-complain cupsd
$ sudo chgrp lp /dev/bus/usb/<bus number>/<device number>
$ sudo chmod 664 /dev/bus/usb/<bus number>/<device number>

and then add the printer manually through System>Administration>Printing>CTRL+N

ilna (a-gaydenko) wrote :

Till,

$ sudo lsmod | grep usb
usbhid 44000 0

$ sudo aa-status
apparmor module is loaded.
11 profiles are loaded.
...
1 processes are in complain mode.
   /usr/sbin/cupsd (13621)

$ lsusb | grep Kyocera
Bus 005 Device 002: ID 0482:0015 Kyocera Corp.

$ sudo ls -l /dev/bus/usb/005/002
crw-r--r-- 1 root lp 189, 513 2009-08-28 22:56 /dev/bus/usb/005/002

This is a state just at the current moment (typing now). As far as I use Kubuntu, I can not use GNOME print config frontend. KDE'd systemsettings/Printer Configuration can not find the printer, as well as CUPS web admin backend (have tried again just now, after typing and copy/paste above console output).

ilna (a-gaydenko) wrote :

Sorry, typo. "as well as CUPS web admin backend" muts be read as "as well as CUPS web admin frontend"

ilf (ilf) wrote :

Works for me (HP LaserJet 1000). Thanks!

Le vendredi 28 août 2009 à 19:31 +0000, ilna a écrit :
> Till,
>
> $ sudo lsmod | grep usb
> usbhid 44000 0
>
> $ sudo aa-status
> apparmor module is loaded.
> 11 profiles are loaded.
> ...
> 1 processes are in complain mode.
> /usr/sbin/cupsd (13621)
>
> $ lsusb | grep Kyocera
> Bus 005 Device 002: ID 0482:0015 Kyocera Corp.
>
> $ sudo ls -l /dev/bus/usb/005/002
> crw-r--r-- 1 root lp 189, 513 2009-08-28 22:56 /dev/bus/usb/005/002

/dev/bus/usb/005/002 need to be 664 and not 644

Did you do :

sudo chmod 664 /dev/bus/usb/<bus number>/<device number>

>
> This is a state just at the current moment (typing now). As far as I use
> Kubuntu, I can not use GNOME print config frontend. KDE'd
> systemsettings/Printer Configuration can not find the printer, as well
> as CUPS web admin backend (have tried again just now, after typing and
> copy/paste above console output).
>

ilna (a-gaydenko) wrote :

Ugh.. My fault, sorry... With 664 the printer was found.

Till, thanks!

ilna (a-gaydenko) wrote :

... was found, but after printing a test page I have noticed there is an 'usb' process belonging to user 'lp', and this process eats 100% of one CPU core (almost all is 'system'). Have stopped cups server, killed 'usb' process (doesn't react on sigterm), started CUPS again, queued a job with few pages - again, eating CPU without terminating after those pages were printed (at least they were printed :-)).

Must I file a new bug? Or - is it better to report new bug after official resolution of this one?

ilf (ilf) wrote :

Oh, same here. Not good.

Please report a new bug for the hanging USB backend. Please put a link to this bug here. You cam also post an upstream bug about this, on http://www.cups.org/str.php.

ilna (a-gaydenko) wrote :

... but failed to register in cups.org. Will anybody more lucky find a minute to file an appropriate upstream bug with regard to this one? https://bugs.launchpad.net/ubuntu/+source/cups/+bug/420797

Thorsten (kdefan) wrote :

I've been having the same problem with a USB-connected Samsung ML-1740 on Kubuntu Karmic w/all recent updates.

Blacklisting usblp and "chgrp lp /dev/bus/usb/<bus>/<device>" helped (I can now print one document at a time), but after each successful print job, the job is shown as still pending and 'usb' process sucks 100% CPU until killed.

Please advise if you need additional help debugging.

tlois (tlois3) wrote :

Since update to karmic a couple of days ago my brother hl2140 is doing the same thing- shows in lsusb, but as idle and not waking up when try to print test page. it worked before update. my hpf4440 is still working. plugged the brother into my other ubuntu 9.04 laptop and it worked fine, so not the printer.

tried above, but did not help.

Eric B (ebischoff) wrote :

Same here. My printer was working fine before I upgraded to karmic, then stopped working after the distribution update.

First, the printer was not seen by CUPS. Solved it by:
 - blacklisting usblp kernel module
 - changing group of /dev/bus/usb/00x/00y device
 - not letting apparmor supervise cupsd operation
as adviced here.

So I was able to add my printer into cups. But printing a test page does not work. The print job shows up in print queue, but never ends. In the list of processes I see :

lp 9520 0.0 0.0 48596 1832 ? S 17:07 0:00 usb://EPSON/Stylus%20DX7000F?serial=B05P108062510410&interface=1 638 root motd 1 finishings=3 media=iso_a4_210x297mm number-up=1 job-uuid=urn:uuid:1f86a76d-d133-3cf5-5dbf-77e34bd688bd job-originating-host-name=localhost

It does not matter whether in 2.6.28 or 2.6.31 kernel.

I hope that helps.

ilna (a-gaydenko) wrote :

Eric,

I have noticed after those owner/rights manipulations and detecting a printer last one stays in suspended state. Try to resume it in CUPS web admin frontend.

Eric B (ebischoff) wrote :

I don't know if this helps, but here is the output of strace

poll([{fd=0, events=POLLIN}, {fd=4, events=POLLIN}], 2, -1) = 1 ([{fd=0, revents=POLLHUP}])
(... repeated in infinite loop)

and here is output of lsof :
COMMAND PID USER FD TYPE DEVICE SIZE/OFF NODE NAME
usb 9846 lp 4u unix 0xffff88007e521b80 0t0 42632 socket

so the "hanging" usb process keeps polling a UNIX domain socket in vain.

Martin Pitt (pitti) on 2009-08-31
Changed in udev (Ubuntu):
status: Triaged → Invalid
Martin Pitt (pitti) on 2009-08-31
tags: added: regression-potential
Martin Pitt (pitti) on 2009-08-31
Changed in cups (Ubuntu Karmic):
status: Triaged → Fix Committed
Martin Pitt (pitti) on 2009-08-31
Changed in udev (Ubuntu Karmic):
importance: High → Wishlist
status: Invalid → Triaged
Changed in cups (Ubuntu Karmic):
status: Fix Committed → Fix Released
Martin Pitt (pitti) on 2009-09-01
Changed in udev (Ubuntu Karmic):
assignee: nobody → Martin Pitt (pitti)
status: Triaged → In Progress
status: In Progress → Won't Fix
assignee: Martin Pitt (pitti) → nobody
Changed in cups (Ubuntu Karmic):
status: Fix Released → Triaged
Changed in udev (Ubuntu):
status: In Progress → Fix Committed
status: Fix Committed → Triaged
Changed in cups (Ubuntu Karmic):
status: Triaged → Fix Committed
Changed in udev (Ubuntu):
status: Triaged → In Progress
Changed in cups (Ubuntu Karmic):
status: Fix Committed → Fix Released
Martin Pitt (pitti) on 2009-09-04
Changed in udev (Ubuntu):
status: In Progress → Fix Committed
Changed in udev (Ubuntu Karmic):
status: Won't Fix → Fix Released
40 comments hidden view all 120 comments
Colin Mills (cm006a5077) wrote :

I have been trying unsuccessfully to install a Canon MP210 usb printer/scanner in Ubuntu Karmic (64 bit). I have tried the fixes listed above, but without success. All I get is an error message "There was an error during the CUPS operation: 'client-error-not-possible'"
lsusb gives:-
Bus 004 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 002 Device 002: ID 04a9:1721 Canon, Inc. MP210 ser
Bus 002 Device 001: ID 1d6b:0002 Linux Foundation 2.0 root hub
Bus 001 Device 004: ID 1058:0402 Western Digital Technologies, Inc.
Bus 001 Device 003: ID 058f:6362 Alcor Micro Corp. Hi-Speed 21-in-1 Flash Card Reader/Writer (Internal/External)
Bus 001 Device 001: ID 1d6b:0002 Linux Foundation 2.0 root hub
Bus 003 Device 002: ID 046d:c018 Logitech, Inc. Optical Wheel Mouse
Bus 003 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub

Previously, I was using Ubuntu Jaunty (64 bit) detected the usb printer/scanner and I was able to select the Canon MP220 driver which worked faultlessly. So its back to Ubuntu Jaunty for me!

Colin, can you attach your /etc/cups/printers.conf file, then remove and re-create your print queue, and after that post your /etc/cups/printers.conf again? Does the new print queue work for you?

Sounds like he has already bailed on the release.

On Monday 28 September 2009 03:53:43 pm Till Kamppeter wrote:
> Colin, can you attach your /etc/cups/printers.conf file, then remove and
> re-create your print queue, and after that post your
> /etc/cups/printers.conf again? Does the new print queue work for you?
>

--
Roland Hughes, President
Logikal Solutions
(630)-205-1593 (cell)
http://www.theminimumyouneedtoknow.com
http://www.infiniteexposure.net
http://www.logikalsolutions.com

Colin Mills (cm006a5077) wrote :

No, I haven't bailed out yet!

Some more background information. If I run from the installation cd in live mode, I can turn on the printer, and the printer icon appears on the desktop, i can click on to it, it opens the printer selection screen, I select the Canon MP220 Printer/Scanner and it installs perfectly ok.

When I repeat the procedure with the installed latest version of Ubuntu Karmic (64 bit) nothing happens, there is no icon, nothing!!! I go to 'System-Administration->Printing' there is no printer icon at all. I select 'New Printer' and it takes me to the 'Select Device' screen. I have confirmed that all Ubuntu updates have been installed.

I select 'Other' and enter "hal:///org/freedesktop/Hal/devices/usb_device_4a9_1721_505BD0_if1_printer_noserial" and try to install the printer manually, but it is obviously not working. I have re-installed Ubuntu Karmic, and have not tried to install the printer manually this time, so at the moment there is no /etc/cups/printers.conf file.

Any help in suggesting the way forward would be appreciated.

Colin Mills (cm006a5077) wrote :

I noticed an error in my previous post. It should have read ' .... and the printer icon appears on the panel' not the desktop.
Sorry!

Steven Harms (sharms) wrote :

This is not resolved yet.

My system:

usblp not loaded -- had to run:
chgrp lp /dev/bus/usb/001/003
chmod 664 /dev/bus/usb/001/003

then it works.

Changed in cups (Ubuntu Karmic):
status: Fix Released → Confirmed

I resolved this issue by hooking up a parallel cable. It was the only way.

On Monday 28 September 2009 07:56:42 pm Steven Harms wrote:
> This is not resolved yet.
>
> My system:
>
> usblp not loaded -- had to run:
> chgrp lp /dev/bus/usb/001/003
> chmod 664 /dev/bus/usb/001/003
>
> then it works.
>
> ** Changed in: cups (Ubuntu Karmic)
> Status: Fix Released => Confirmed
>

--
Roland Hughes, President
Logikal Solutions
(630)-205-1593 (cell)
http://www.theminimumyouneedtoknow.com
http://www.infiniteexposure.net
http://www.logikalsolutions.com

Jeffrey Baker (jwbaker) wrote :

I also re-re-re-confirm that this is still just as busted as ever.

Everyone with problems please run the following shell commands:

ls -l /dev/bus/usb/*/*
lsusb
/usr/lib/cups/filter/usb
/usr/lib/cups/filter/hp
lpinfo -v
lpstat -v
lsusb -vvv

and post all the output here. Thanks.

Note also that there is no "hal" CUPS backend any more. If your printer's URI starts with "hal:" please remove your print queue and create a new one. If you still cannot print after that, run the commands and post the output.

GuyR (guy-rouger) wrote :

Hello all,
Below my status:
lsusb
Bus 001 Device 001: ID 1d6b:0002 Linux Foundation 2.0 root hub
Bus 002 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 003 Device 002: ID 04b8:080f Seiko Epson Corp. Stylus Photo RX425 scanner
Bus 003 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 004 Device 002: ID 058f:9360 Alcor Micro Corp. 8-in-1 Media Card Reader
Bus 004 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
I declare my printer as it:
sudo lpadmin -p RX425 -P /etc/cups/ppd/Stylus_Photo_RX420.ppd -v /dev/usbmon3
sudo chgrp lp /dev/bus/usb/003/002
sudo chmod 664 /dev/bus/usb/003/002
At this step no more errors in CUPS error logfile but no output at the printer side!
Finally I created a new printer through CUPS http://localhost:631/ (seen as a RX420 despite it is a RX425???)
then deleted the old one (RX425)
Set the new one as partaged, enabled and default one
And all is working now!
I still do not understood why, but it is ok for me as I am not an expert

lpstat -t
le programmateur s’exécute
destination système par défaut : EPSON_Stylus_Photo_RX420
périphérique pour EPSON_Stylus_Photo_RX420 : usb://EPSON/Stylus%20Photo%20RX420?serial=LJ2030412222119500&i nterface=1
EPSON_Stylus_Photo_RX420 acceptant des requêtes depuis lun. 28 sept. 2009 18:21:33 CEST
l’imprimante EPSON_Stylus_Photo_RX420 est inactive, mais activée depuis lun. 28 sept. 2009 18:21:33 CEST
Finished page 1...

Colin Mills (cm006a5077) wrote :
Download full text (18.3 KiB)

As requested, I have runthe commands
ls -l /dev/bus/usb/*/*
lsusb
/usr/lib/cups/filter/usb
/usr/lib/cups/filter/hp
lpinfo -v
lpstat -v
lsusb -vvv
and these are the output. Still can't get my printer recognised.

colin@colin-desktop:~$ ls -l /dev/bus/usb/*/*
crw-rw-r-- 1 root root 189, 0 2009-09-29 08:46 /dev/bus/usb/001/001
crw-rw-r-- 1 root root 189, 2 2009-09-29 08:46 /dev/bus/usb/001/003
crw-rw-r-- 1 root root 189, 3 2009-09-29 08:56 /dev/bus/usb/001/004
crw-rw-r-- 1 root root 189, 128 2009-09-29 08:46 /dev/bus/usb/002/001
crw-rw-r--+ 1 root root 189, 129 2009-09-29 09:08 /dev/bus/usb/002/002
crw-rw-r-- 1 root root 189, 256 2009-09-29 08:46 /dev/bus/usb/003/001
crw-rw-r-- 1 root root 189, 257 2009-09-29 08:46 /dev/bus/usb/003/002
crw-rw-r-- 1 root root 189, 384 2009-09-29 08:46 /dev/bus/usb/004/001

colin@colin-desktop:~$ lsusb
Bus 002 Device 002: ID 04a9:1721 Canon, Inc. MP210 ser
Bus 002 Device 001: ID 1d6b:0002 Linux Foundation 2.0 root hub
Bus 001 Device 004: ID 1058:0402 Western Digital Technologies, Inc.
Bus 001 Device 003: ID 058f:6362 Alcor Micro Corp. Hi-Speed 21-in-1 Flash Card Reader/Writer (Internal/External)
Bus 001 Device 001: ID 1d6b:0002 Linux Foundation 2.0 root hub
Bus 004 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 003 Device 002: ID 046d:c018 Logitech, Inc. Optical Wheel Mouse
Bus 003 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub

colin@colin-desktop:~$ /usr/lib/cups/filter/usb
bash: /usr/lib/cups/filter/usb: No such file or directory

colin@colin-desktop:~$ /usr/lib/cups/filter/hp
bash: /usr/lib/cups/filter/hp: No such file or directory

colin@colin-desktop:~$ lpinfo -v
network http
serial serial:/dev/ttyS0?baud=115200
network beh
network smb
network ipp
network lpd
direct scsi
network socket
direct parallel:/dev/lp0
direct hp
direct hpfax

colin@colin-desktop:~$ lpstat -v
device for Canon-PIXMA-MP220: http://localhost:631/

colin@colin-desktop:~$ lsusb -vvv

Bus 002 Device 002: ID 04a9:1721 Canon, Inc. MP210 ser
Device Descriptor:
  bLength 18
  bDescriptorType 1
  bcdUSB 2.00
  bDeviceClass 0 (Defined at Interface level)
  bDeviceSubClass 0
  bDeviceProtocol 0
  bMaxPacketSize0 64
  idVendor 0x04a9 Canon, Inc.
  idProduct 0x1721 MP210 ser
  bcdDevice 1.05
  iManufacturer 1 Canon
  iProduct 2 MP210 series
  iSerial 3 33D935
  bNumConfigurations 1
  Configuration Descriptor:
    bLength 9
    bDescriptorType 2
    wTotalLength 62
    bNumInterfaces 2
    bConfigurationValue 1
    iConfiguration 0
    bmAttributes 0xc0
      Self Powered
    MaxPower 2mA
    Interface Descriptor:
      bLength 9
      bDescriptorType 4
      bInterfaceNumber 0
      bAlternateSetting 0
      bNumEndpoints 3
      bInterfaceClass 255 Vendor Specific Class
      bInterfaceSubClass 0
      bInterfaceProtocol 255
      iInterface 0
      Endpoint Descriptor:
        bLength 7
        bDe...

Jeffrey Baker (jwbaker) wrote :
Download full text (39.2 KiB)

crw-rw-r-- 1 root root 189, 0 2009-09-28 13:51 /dev/bus/usb/001/001
crw-rw-r-- 1 root root 189, 1 2009-09-28 13:51 /dev/bus/usb/001/002
crw-rw-r-- 1 root root 189, 3 2009-09-28 13:51 /dev/bus/usb/001/004
crw-rw-r-- 1 root root 189, 4 2009-09-28 13:51 /dev/bus/usb/001/005
crw-rw-r-- 1 root root 189, 128 2009-09-28 13:51 /dev/bus/usb/002/001
crw-rw-r-- 1 root root 189, 256 2009-09-28 13:51 /dev/bus/usb/003/001
crw-rw-r-- 1 root root 189, 384 2009-09-28 13:51 /dev/bus/usb/004/001
crw-rw-r-- 1 root root 189, 385 2009-09-28 13:51 /dev/bus/usb/004/002
crw-rw-r-- 1 root root 189, 512 2009-09-28 13:51 /dev/bus/usb/005/001
crw-rw-r-- 1 root root 189, 640 2009-09-28 13:51 /dev/bus/usb/006/001
crw-rw-r--+ 1 root root 189, 641 2009-09-29 09:34 /dev/bus/usb/006/002
crw-rw-r-- 1 root root 189, 768 2009-09-28 13:51 /dev/bus/usb/007/001
crw-rw-r-- 1 root root 189, 896 2009-09-28 13:51 /dev/bus/usb/008/001
Bus 006 Device 002: ID 04b8:0808 Seiko Epson Corp. Stylus CX5200
Bus 006 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 002 Device 001: ID 1d6b:0002 Linux Foundation 2.0 root hub
Bus 008 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 007 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 001 Device 002: ID 058f:6362 Alcor Micro Corp. Hi-Speed 21-in-1 Flash Card Reader/Writer (Internal/External)
Bus 001 Device 005: ID 046d:c51a Logitech, Inc. MX Revolution/G7 Cordless Mouse
Bus 001 Device 004: ID 0424:2504 Standard Microsystems Corp. USB 2.0 Hub
Bus 001 Device 001: ID 1d6b:0002 Linux Foundation 2.0 root hub
Bus 005 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 004 Device 002: ID 0a12:0001 Cambridge Silicon Radio, Ltd Bluetooth Dongle (HCI mode)
Bus 004 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 003 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
network beh
network smb
network ipp
direct scsi
network http
network socket
network lpd
direct hp
serial serial:/dev/ttyS0?baud=115200
direct hpfax

Bus 006 Device 002: ID 04b8:0808 Seiko Epson Corp. Stylus CX5200
Device Descriptor:
  bLength 18
  bDescriptorType 1
  bcdUSB 1.10
  bDeviceClass 0 (Defined at Interface level)
  bDeviceSubClass 0
  bDeviceProtocol 0
  bMaxPacketSize0 8
  idVendor 0x04b8 Seiko Epson Corp.
  idProduct 0x0808 Stylus CX5200
  bcdDevice 1.00
  iManufacturer 1 EPSON
  iProduct 2 USB MFP
  iSerial 3 HS0290402250123170
  bNumConfigurations 1
  Configuration Descriptor:
    bLength 9
    bDescriptorType 2
    wTotalLength 55
    bNumInterfaces 2
    bConfigurationValue 1
    iConfiguration 4 USB MFP
    bmAttributes 0xc0
      Self Powered
    MaxPower 2mA
    Interface Descriptor:
      bLength 9
      bDescriptorType 4
      bInterfaceNumber 0
      bAlternateSetting 0
      bNumEndpoints 2
      bInterfaceClass 255 Vendor Specific Class
      bInterfaceSubClass 255 Vendor Specific Subclass
      bInterfaceProtocol 255 Vendo...

Jeffrey Baker (jwbaker) wrote :

I noted that the printer has an ACL so here's the output of getfacl:

# file: dev/bus/usb/006/002
# owner: root
# group: root
user::rw-
user:jwb:rw-
group::rw-
mask::rw-
other::r--

Martin Pitt (pitti) wrote :

Seems not all USB printers are covered by the udev rule, so I revert the recent change in cups and have the usb backend run as root again for now.

Fix committed to cups bzr, will upload after karmic beta.

Changed in cups (Ubuntu Karmic):
status: Confirmed → Fix Committed
Danny Wood (danwood76) wrote :

Im sorry but this is not fixed.

To make my printer work I have to run this each boot:
"sudo aa-enforce cupsd"

Some of the commands gave useless or no info but the ones that might be useful:
My printer wasn't visible with the lsusb commands like it used to be and these were run after the above command was run.

----

lpinfo -v
serial serial:/dev/ttyS0?baud=115200
serial serial:/dev/ttyS1?baud=115200
direct scsi
network lpd
network ipp
network beh
network socket
network http
network smb
direct hp
direct hpfax
direct usb://Samsung/ML-1210?serial=?

----

device for Samsung-ML-1210: usb://Samsung/ML-1210?serial=?

----

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package cups - 1.4.1-4

---------------
cups (1.4.1-4) unstable; urgency=low

  [ Till Kamppeter ]
  * debian/patches/usb-backend-both-usblp-and-libusb.dpatch: Make the USB
    backend supporting both printer access via libusb and via the usblp kernel
    module. Make it also printing via libusb if the URI for the queue was
    generated via usblp and vice versa. This should solve most USB printing
    problems which occured on the transition to CUPS 1.4.x (LP: #420015,
    LP: #436495; Closes: #546558, #545288, #545453).

  [ Martin Pitt ]
  * debian/rules: Make the USB backend run as root again, udev rules do not
    cover all printers. (LP: #420015)
  * Drop debian/blacklist-cups.conf, and remove it on upgrade. With Till's fix
    from above this is not necessary any more.

cups (1.4.1-3) unstable; urgency=low

  * Add disable-pie-mipsen.dpatch: Disable PIE on mipsen, its binutils
    segfaults with it. (Closes: #548246)

 -- Martin Pitt <email address hidden> Wed, 30 Sep 2009 15:17:53 +0200

Changed in cups (Ubuntu Karmic):
status: Fix Committed → Fix Released
Martin Pitt (pitti) on 2009-10-02
Changed in cups (Ubuntu Karmic):
assignee: Martin Pitt (pitti) → nobody
Colin Mills (cm006a5077) wrote :

I downloaded the latest beta Ubuntu live cd and tried to install my Canon MP210 scanner, but as I reported earlier, the distribution fails to detect my printer. Any idea when this problem is likely to be resolved?

Martin Beltov (mbeltov) wrote :

Same for me. I need to run manual commands in order for cups to "see" the usb printer

Fraser Murray (fraserm) wrote :

The fixed version is scheduled for build in 45 minutes.

Colin Mills (cm006a5077) wrote :

I have just downloaded the latest Ubuntu Karmic updates and my MP210 printer now works!!!! I just wanted to say a big thank you for all the developers involved.

Jeffrey Baker (jwbaker) wrote :

This also fixed my Epson Stylus CX5400.

Download full text (8.1 KiB)

I have downloaded the latest updates, but hp 1020 don't work yet. cups do not see my printer.

ruslan@ruslan:~$ ls -l /dev/bus/usb/*/*
crw-rw-r-- 1 root root 189, 0 2009-10-04 23:25 /dev/bus/usb/001/001
crw-rw-r--+ 1 root lp 189, 1 2009-10-04 23:28 /dev/bus/usb/001/002
crw-rw-r-- 1 root root 189, 128 2009-10-04 23:25 /dev/bus/usb/002/001
crw-rw-r-- 1 root root 189, 256 2009-10-04 23:25 /dev/bus/usb/003/001

ruslan@ruslan:~$ lsusb
Bus 001 Device 002: ID 03f0:2b17 Hewlett-Packard LaserJet 1020
Bus 001 Device 001: ID 1d6b:0002 Linux Foundation 2.0 root hub
Bus 003 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 002 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub

/usr/lib/cups/filter/usb No such file or directory
/usr/lib/cups/filter/hp No such file or directory

cat: /usr/lib/cups/filter/hp: No such file or directory
ruslan@ruslan:~$ lpinfo -v
network smb
network beh
serial serial:/dev/ttyS0?baud=115200
serial serial:/dev/ttyS1?baud=115200
network http
direct scsi
direct parallel:/dev/lp0
network ipp
network socket
network lpd

ruslan@ruslan:~$ lsusb -vvv

Bus 001 Device 002: ID 03f0:2b17 Hewlett-Packard LaserJet 1020
Device Descriptor:
  bLength 18
  bDescriptorType 1
  bcdUSB 2.00
  bDeviceClass 0 (Defined at Interface level)
  bDeviceSubClass 0
  bDeviceProtocol 0
  bMaxPacketSize0 64
  idVendor 0x03f0 Hewlett-Packard
  idProduct 0x2b17 LaserJet 1020
  bcdDevice 1.00
  iManufacturer 1
  iProduct 2
  iSerial 3
  bNumConfigurations 1
  Configuration Descriptor:
    bLength 9
    bDescriptorType 2
    wTotalLength 32
    bNumInterfaces 1
    bConfigurationValue 1
    iConfiguration 0
    bmAttributes 0xc0
      Self Powered
    MaxPower 98mA
    Interface Descriptor:
      bLength 9
      bDescriptorType 4
      bInterfaceNumber 0
      bAlternateSetting 0
      bNumEndpoints 2
      bInterfaceClass 7 Printer
      bInterfaceSubClass 1 Printer
      bInterfaceProtocol 2 Bidirectional
      iInterface 0
      Endpoint Descriptor:
        bLength 7
        bDescriptorType 5
        bEndpointAddress 0x01 EP 1 OUT
        bmAttributes 2
          Transfer Type Bulk
          Synch Type None
          Usage Type Data
        wMaxPacketSize 0x0200 1x 512 bytes
        bInterval 0
      Endpoint Descriptor:
        bLength 7
        bDescriptorType 5
        bEndpointAddress 0x81 EP 1 IN
        bmAttributes 2
          Transfer Type Bulk
          Synch Type None
          Usage Type Data
        wMaxPacketSize 0x0200 1x 512 bytes
        bInterval 0
can't get device qualifier: Connection timed out
can't get debug descriptor: Connection timed out
Device Status: 0x0001
  Self Powered

Bus 001 Device 001: ID 1d6b:0002 Linux F...

Read more...

Can everyone with problems please run the following shell commands:

lsmod | grep usblp
ls -l /dev/usb/lp*
ls -l /dev/bus/usb/*/*
lsusb
/usr/lib/cups/backend/usb
/usr/lib/cups/backend/hp
lpinfo -v
lpstat -v
lsusb -vvv

Hello again.
Today I turned on computer and updated ubuntu. I don't know that is the reason, but now printer is working very good. And I am happy. Thank you.

databubble (phil-linttell) wrote :

My printer still isn't working. I reported this in https://bugs.launchpad.net/ubuntu/+source/cups/+bug/443981 but was directed here.

The following is a snippet from dmesg where I turn the printer off, and then on...

[71725.855070] usb 1-2: usbfs: interface 0 claimed by usb-storage while 'usb' sets config #1
[72207.592101] usb 1-2: usbfs: interface 0 claimed by usb-storage while 'usb' sets config #1
[72231.720873] usb 1-2: usbfs: interface 0 claimed by usb-storage while 'usb' sets config #1
[72566.124804] usb 1-2: usbfs: interface 0 claimed by usb-storage while 'usb' sets config #1
[72584.698424] usb 1-2: usbfs: interface 0 claimed by usb-storage while 'usb' sets config #1
[72660.539781] usb 1-2: USB disconnect, address 7
[72668.121306] usb 1-2: new high speed USB device using ehci_hcd and address 8
[72668.273324] usb 1-2: configuration #1 chosen from 1 choice
[72668.280149] scsi12 : SCSI emulation for USB Mass Storage devices
[72668.282795] usb-storage: device found at 8
[72668.282800] usb-storage: waiting for device to settle before scanning
[72673.281613] usb-storage: device scan complete
[72673.285603] scsi 12:0:0:0: Direct-Access EPSON Stylus Storage 1.00 PQ: 0 ANSI: 2
[72673.286954] sd 12:0:0:0: Attached scsi generic sg4 type 0
[72673.298289] sd 12:0:0:0: [sdd] Attached SCSI removable disk

It doesn't seem to be recognized as a printer at all. However, it did work under jaunty and in early alphas of karmic.

Also, I note that the udev rule changes mentioned in #74 are not included in udev - 174~-5. To verify, I tried making the changes to usb and printer by hand, and then did a "apt-get install --reinstall udev" and my changes were wiped out. To get the device permissions below, I had to change the group ownership by hand.

pitti, it seems that the new udev rule for libusb-accessed USB printers got lost again. You introduced it with udev 147~-1 (comment #80) and in the current version (174~-5) it seems to have disappeared again. Can you check?

Changed in udev (Ubuntu Karmic):
status: Fix Released → Triaged
milestone: none → ubuntu-9.10
Martin Pitt (pitti) wrote :

They are still in /lib/udev/rules.d/50-udev-default.rules, where they are supposed to be:

# hplip and cups 1.4+ use raw USB devices, so permissions should be similar to
# the ones from the old usblp kernel module
SUBSYSTEM=="usb", ENV{DEVTYPE}=="usb_device", ENV{ID_USB_INTERFACES}=="", IMPORT{program}="usb_id --export %p"
SUBSYSTEM=="usb", ENV{DEVTYPE}=="usb_device", ENV{ID_USB_INTERFACES}==":0701*:", GROUP="lp", MODE="660"

Changed in udev (Ubuntu Karmic):
status: Triaged → Fix Released
ilf (ilf) wrote :

My HP LaserJet 1000 still doesn't print.
I am not sure if the reason is still related to this. But since it works on my Jaunty box, I am adding this here hoping to get it fixed for the Karmic release.

After all these usblp changes, when blacklisting usblp the firmware isn't uploaded to the printer correctly, because foo2zjs needs the printer device in /dev/usb, provided by usblp: https://bugs.launchpad.net/ubuntu/+source/foo2zjs/+bug/425300
usblp is not blacklisted any more, so this works now.

However, the printer still does not print, telling me in /var/log/cups/error_log to blacklist usblp again, when I have "more than one HP LaserJet 1000 connected": https://bugs.launchpad.net/ubuntu/+source/cups/+bug/450513

I really hope this can be fixed for Karmic, I need my printer. Thanks

Dušan Miletić (karl3) wrote :

the same thing with canon lbp2900 - still not detected

zob (zob) wrote :

Ok. I have the same bug. My printer is Brother HL-2140. Not able to be "seen". All my other usb-hardware works fine. My cups-version is 1.4.1-5ubuntu2. I'm on ubuntu 9.10, kernel 2.6.31-14-generic. Usb connected directly to a computer not through a hub (connection, cable, usb-port and printer verified to work in windows). Also printer worked under 9.04.

Here are my outputs:

lars@lars-desktop:~$ lsmod | grep usblp
usblp 15136 0

lars@lars-desktop:~$ ls -l /dev/usb/lp*
crw-rw---- 1 root lp 180, 0 2009-11-04 19:53 /dev/usb/lp0

lars@lars-desktop:~$ ls -l /dev/bus/usb/*/*
crw-rw-r-- 1 root vboxusers 189, 0 2009-11-04 20:05 /dev/bus/usb/001/001
crw-rw-r-- 1 root vboxusers 189, 1 2009-11-04 20:05 /dev/bus/usb/001/002
crw-rw-r-- 1 root vboxusers 189, 2 2009-11-04 20:05 /dev/bus/usb/001/003
crw-rw-r-- 1 root vboxusers 189, 4 2009-11-04 20:05 /dev/bus/usb/001/005
crw-rw-r-- 1 root vboxusers 189, 128 2009-11-04 20:05 /dev/bus/usb/002/001
crw-rw---- 1 root lp 189, 130 2009-11-04 19:53 /dev/bus/usb/002/003
crw-rw-r-- 1 root vboxusers 189, 256 2009-11-04 20:05 /dev/bus/usb/003/001

lars@lars-desktop:~$ lsusb
Bus 002 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 001 Device 005: ID 0499:1011 Yamaha Corp. P-250
Bus 001 Device 003: ID 05e3:0606 Genesys Logic, Inc. USB 2.0 Hub / D-Link DUB-H4 USB 2.0 Hub
Bus 001 Device 002: ID 0bc2:3101 Seagate RSS LLC
Bus 001 Device 001: ID 1d6b:0002 Linux Foundation 2.0 root hub
Bus 003 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub

lars@lars-desktop:~$ /usr/lib/cups/backend/usb
bash: /usr/lib/cups/backend/usb: Permission denied

lars@lars-desktop:~$ lpinfo -v
lpinfo: Connection refused

lars@lars-desktop:~$ lpstat -v
lpstat: Connection refused

May something interesting happened when I did sudo aa-enforce cupsd because before that turning on my printer and tailing dmesg would give me:

[ 711.292551] usb 2-3: new full speed USB device using ohci_hcd and address 2
[ 711.528665] usb 2-3: configuration #1 chosen from 1 choice
[ 711.612618] usblp0: USB Bidirectional printer dev 2 if 0 alt 0 proto 2 vid 0x04F9 pid 0x0033
[ 711.612639] usbcore: registered new interface driver usblp

After said command dmesg returns the following:

[ 2850.049704] type=1505 audit(1257360769.685:22): operation="profile_replace" pid=6172 name=/usr/lib/cups/backend/cups-pdf
[ 2850.049942] type=1505 audit(1257360769.685:23): operation="profile_replace" pid=6172 name=/usr/sbin/cupsd
[ 2869.722555] usb 2-3: new full speed USB device using ohci_hcd and address 3
[ 2869.961662] usb 2-3: configuration #1 chosen from 1 choice
[ 2869.976057] usblp0: USB Bidirectional printer dev 3 if 0 alt 0 proto 2 vid 0x04F9 pid 0x0033

So now at least were talking cups.

zob (zob) wrote :

I just found out that if I run 9.10 64bit from the LiveCD I installed from, there's no problem. The printer just show up and is even recognized as soon as I turn it on.

zob (zob) wrote :

Sorry. Just solved my problem.
To get a faster boot with a dual-core machine I made a change in /etc/init.d/rc where i changed concurrency=none to concurrency=shell.
Setting it back to concurrency=none solved this problem and another problem I had with Grub.

giorgos (gspathoulas) on 2009-11-10
Changed in cups (Ubuntu):
status: Fix Released → Fix Committed
status: Fix Committed → Fix Released
Paul Cullum (paul-cullum) wrote :

I'm fully updated with the latest patches but could group permissions seem to be assigned to vboxusers...

$ ls -l /dev/bus/usb/*/*
crw-rw-r-- 1 root vboxusers 189, 0 2009-11-13 10:34 /dev/bus/usb/001/001
crw-rw-r-- 1 root vboxusers 189, 128 2009-11-13 10:34 /dev/bus/usb/002/001
crw-rw-r-- 1 root vboxusers 189, 256 2009-11-13 10:34 /dev/bus/usb/003/001
crw-rw-r-- 1 root vboxusers 189, 384 2009-11-13 10:34 /dev/bus/usb/004/001
crw-rw-r-- 1 root vboxusers 189, 512 2009-11-13 10:34 /dev/bus/usb/005/001
crw-rw-r-- 1 root vboxusers 189, 513 2009-11-13 10:34 /dev/bus/usb/005/002
crw-rw-r-- 1 root vboxusers 189, 640 2009-11-13 10:34 /dev/bus/usb/006/001
crw-rw-r-- 1 root vboxusers 189, 646 2009-11-18 13:39 /dev/bus/usb/006/007
crw-rw-r-- 1 root vboxusers 189, 768 2009-11-13 10:34 /dev/bus/usb/007/001

Paul Loughman (snowhog) wrote :

System: Kernel 2.6.31-17-generic i686 (32 bit) Distro Ubuntu 9.10 karmic
CUPS: 1.4.1 (Installed Version: 1.4.1-5ubuntu2.1)
modinfo usblp:
filename: /lib/modules/2.6.31-17-generic/kernel/drivers/usb/class/usblp.ko
license: GPL
description: USB Printer Device Class driver
author: Michael Gee, Pavel Machek, Vojtech Pavlik, Randy Dunlap, Pete Zaitcev, David Paschal
srcversion: 2E3BEEBC12905CCBCD57D87
alias: usb:v04B8p0202d*dc*dsc*dp*ic*isc*ip*
alias: usb:v*p*d*dc*dsc*dp*ic07isc01ip03*
alias: usb:v*p*d*dc*dsc*dp*ic07isc01ip02*
alias: usb:v*p*d*dc*dsc*dp*ic07isc01ip01*
alias: usb:v*p*d*dc07dsc01dp03ic*isc*ip*
alias: usb:v*p*d*dc07dsc01dp02ic*isc*ip*
alias: usb:v*p*d*dc07dsc01dp01ic*isc*ip*
depends:
vermagic: 2.6.31-17-generic SMP mod_unload modversions 586
parm: proto_bias:Favourite protocol number (int)

tail -f /var/log/messages:
Jan 24 15:35:15 myotherbrain kernel: [ 1209.912127] usb 2-2: USB disconnect, address 2
Jan 24 15:35:15 myotherbrain kernel: [ 1209.912443] usblp0: removed
Jan 24 15:35:21 myotherbrain kernel: [ 1216.612055] usb 2-2: new full speed USB device using uhci_hcd and address 3
Jan 24 15:35:22 myotherbrain kernel: [ 1216.799305] usb 2-2: configuration #1 chosen from 1 choice
Jan 24 15:35:22 myotherbrain kernel: [ 1216.847494] usblp0: USB Bidirectional printer dev 3 if 0 alt 1 proto 2 vid 0x1309 pid 0xF002

foomatic-gui, under Add > Choose printer connection shows a selectable entry for:
USB Printer #1 Unknown

Selecting it and clicking Forward allows me to enter Printer Identification data. Clicking Forward I am allowed to select the printer make and model - Panasonic KX-P4410 - and presented with three printer drivers:
gutenprint-ijs-simplified.5.2
gutenprint-ijs.5.2
ljet2p (recommended)

Selecting ljet2p (recommended) and clicking Forward and Apply results in the printer being 'added' but it fails to print. It isn't permitting the selection of the CUPS+ drivers, which in my Jaunty 9.04 installation, works flawlessly.

What can I provide that might aid in getting this bug fixed?

Paul Loughman (snowhog) wrote :

Also, CUPS does not see this USB printer either.

Paul Loughman (snowhog) wrote :

giorgos on 2009-11-10
Changed in cups (Ubuntu):
  status: Fix Committed → Fix Released

My udev version is:
apt-cache show udev | grep Version
Version: 147~-6.1
Version: 147~-6

My USB printer does not work in Kubuntu Karmic:
Kernel 2.6.31-17-generic i686 (32 bit) Distro Ubuntu 9.10 karmic

KDE version;
4.3.5

Please tell me how to fix this. If as giorgos says, it has been fixed and released, why doesn't my USP printer work in Karmic?

Yuan Chao (yuanchao) wrote :

I have a USB to Printer port cable to connect my old HP DJ890C. It can only be seen by lsusb if run by root:
Bus 004 Device 005: ID 04b4:4100 Cypress Semiconductor Corp.

For Fedora 7 or 11 (ever tried), when plugged in, 'usblp' will be loaded and '/dev/usb/lp0' will be setup. However, for Ubuntu 810, 904 or 910, usblp won't be loaded and CUPS can't see it. The kernel message show the following error:

[ 2564.232074] usb 4-2: new full speed USB device using ohci_hcd and address 4
[ 2564.439134] usb 4-2: config 1 has an invalid descriptor of length 26, skipping remainder of the config
[ 2564.439150] usb 4-2: config 1 interface 0 has no altsetting 0
[ 2564.463318] usb 4-2: configuration #1 chosen from 1 choice
[ 2564.467521] usb 4-2: can't set config #1, error -32

If I manually loads usblp, after issuing 'lpinfo -v', the device file will be setup and I can use the printer if manually set the URI. (usblp can't see it w/o lpinfo; CUPS can't probe it anyway)

[ 2643.521134] usblp0: USB Bidirectional printer dev 4 if 0 alt 2 proto 2 vid 0x04B4 pid 0x4100

I'm wondering if this is simply a new device should be set in udev rules, or udev rule is still broken here?

Atti (atti84it) wrote :

On Lucid Lynx 10.04 after updates I was having the same problem. My dmesg had the line:
[ 279.196192] usb 4-1: usbfs: interface 0 claimed by usblp while 'usb' sets config #1

and "usblp" module was still loaded.

I solved everything by blacklisting the usblp module, but not chmodding the /dev/bus... files.

I used these commands (as root):
echo "blacklist usblp" > /etc/modprobe.d/blacklist-cups.conf
rmmod usblp
/etc/init.d/cups restart
update-initramfs -u

should we file a new bug?

nh2 (nh2) wrote :

We should indeed check if this is still a problem.
In my dmesg on 10.04 with a HP LaserJet 2200DN on cable plug-in:

[295072.380908] usblp1: USB Bidirectional printer dev 8 if 0 alt 1 proto 2 vid 0x03F0 pid 0x0217
[295073.503061] usb 4-1: usbfs: interface 0 claimed by usblp while 'usb' sets config #1
[295073.504937] usb[22618]: segfault at 0 ip 001cbdbb sp bf9b3e94 error 4 in libc-2.11.1.so[157000+153000]
[295073.506473] type=1503 audit(1278841151.903:852): operation="open" pid=22614 parent=22613 profile="/usr/sbin/cupsd" requested_mask="w::" denied_mask="w::" fsuid=0 ouid=0 name="/dev/ttyUSB0"

I guess the last line is related to another problem, but usblp gets still loaded when I attach the USB printer cable unless blacklisted and segfaults in libc aren't that cool, either. They stop appearing when I blacklist usblp.

The line
[295073.503061] usb 4-1: usbfs: interface 0 claimed by usblp while 'usb' sets config #1
does also appear on other 10.04 laptops I tested, but printing works fine there.

pinzia (pinzia) wrote :

I have similar problem on lucid lynx 64bit

[ 34.200259] usb 8-2: usbfs: interface 0 claimed by usblp while 'usb' sets config #1
[ 34.200288] usb 8-1: usbfs: interface 1 claimed by usblp while 'usb' sets config #1

$ lpstat -a
ML-1710 accetta richieste da gio 15 lug 2010 15:54:52 CEST
ML-2010 accetta richieste da ven 18 giu 2010 16:32:28 CEST
Stampanti accetta richieste da sab 05 giu 2010 18:11:38 CEST

Changed in cups (Ubuntu):
status: Fix Released → New
tags: added: regression-release
removed: regression-potential
Martin Pitt (pitti) on 2012-01-30
Changed in cups (Ubuntu):
status: New → Fix Released
Displaying first 40 and last 40 comments. View all 120 comments or add a comment.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.